blob: eabbab32a917b13cbc3b1397e099351a161a4688 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043
44export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070045export JAVAC="javac -g"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010046export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070047export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070048export NEED_DEX="true"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010049export USE_JACK="false"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
76# If the tree is compiled with Jack, build test with Jack by default.
77if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then
78 USE_JACK="true"
79fi
80
81# ANDROID_BUILD_TOP is not set in a build environment.
82if [ -z "$ANDROID_BUILD_TOP" ]; then
83 export ANDROID_BUILD_TOP=$oldwd
84fi
85
86# If JACK_VM_COMMAND is not set, assume it launches the prebuilt jack-launcher.
87if [ -z "$JACK_VM_COMMAND" ]; then
88 if [ ! -z "$TMPDIR" ]; then
89 jack_temp_dir="-Djava.io.tmpdir=$TMPDIR"
90 fi
91 export JACK_VM_COMMAND="java -Dfile.encoding=UTF-8 -Xms2560m -XX:+TieredCompilation $jack_temp_dir -jar $ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack-launcher.jar"
92fi
93
94# If JACK_CLASSPATH is not set, assume it only contains core-libart.
95if [ -z "$JACK_CLASSPATH" ]; then
96 export JACK_CLASSPATH="$ANDROID_BUILD_TOP/out/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack"
97fi
98
99# If JACK_JAR is not set, assume it is located in the prebuilts directory.
100if [ -z "$JACK_JAR" ]; then
101 export JACK_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jack.jar"
102fi
103
104# If JILL_JAR is not set, assume it is located in the prebuilts directory.
105if [ -z "$JILL_JAR" ]; then
106 export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar"
107fi
108
109export JACK="$JACK -g -cp $JACK_CLASSPATH"
110export JILL="java -jar $JILL_JAR"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -0800111
jeffhao5d1ac922011-09-29 17:41:15 -0700112info="info.txt"
113build="build"
114run="run"
115expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700116check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700117output="output.txt"
118build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100119cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700120strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700121lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -0700122run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000123build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700124
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000125debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700126prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700127target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700128dev_mode="no"
129update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700130debug_mode="no"
131relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -0800132runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700133usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700134build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700135suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700136trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700137trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700138basic_verify="false"
139gc_verify="false"
140gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700141strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700142always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700143never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700144have_dex2oat="yes"
145have_patchoat="yes"
146have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700147image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -0700148pic_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000149android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700150
151while true; do
152 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700153 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700154 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100155 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700156 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800157 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700158 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800159 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700160 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700161 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100162 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100163 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700164 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800165 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700166 lib="libart.so"
167 shift
168 elif [ "x$1" = "x--dalvik" ]; then
169 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800170 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700171 shift
Alex Light03a112d2014-08-25 13:25:56 -0700172 elif [ "x$1" = "x--no-dex2oat" ]; then
173 have_dex2oat="no"
174 shift
175 elif [ "x$1" = "x--no-patchoat" ]; then
176 have_patchoat="no"
177 shift
178 elif [ "x$1" = "x--no-image" ]; then
179 have_image="no"
180 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700181 elif [ "x$1" = "x--pic-image" ]; then
182 pic_image_suffix="-pic"
183 shift
184 elif [ "x$1" = "x--pic-test" ]; then
185 run_args="${run_args} --pic-test"
186 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700187 elif [ "x$1" = "x--relocate" ]; then
188 relocate="yes"
189 shift
190 elif [ "x$1" = "x--no-relocate" ]; then
191 relocate="no"
192 shift
193 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100194 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700195 prebuild_mode="yes"
196 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000197 elif [ "x$1" = "x--debuggable" ]; then
198 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000199 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000200 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700201 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100202 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700203 prebuild_mode="no"
204 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700205 elif [ "x$1" = "x--gcverify" ]; then
206 basic_verify="true"
207 gc_verify="true"
208 shift
209 elif [ "x$1" = "x--gcstress" ]; then
210 basic_verify="true"
211 gc_stress="true"
212 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700213 elif [ "x$1" = "x--image" ]; then
214 shift
215 image="$1"
216 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700217 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000218 elif [ "x$1" = "x-Xcompiler-option" ]; then
219 shift
220 option="$1"
221 run_args="${run_args} -Xcompiler-option $option"
222 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700223 elif [ "x$1" = "x--runtime-option" ]; then
224 shift
225 option="$1"
226 run_args="${run_args} --runtime-option $option"
227 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700228 elif [ "x$1" = "x--gdb-arg" ]; then
229 shift
230 gdb_arg="$1"
231 run_args="${run_args} --gdb-arg $gdb_arg"
232 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700233 elif [ "x$1" = "x--debug" ]; then
234 run_args="${run_args} --debug"
235 shift
236 elif [ "x$1" = "x--gdb" ]; then
237 run_args="${run_args} --gdb"
238 dev_mode="yes"
239 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700240 elif [ "x$1" = "x--strace" ]; then
241 strace="yes"
242 run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
243 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700244 elif [ "x$1" = "x--zygote" ]; then
245 run_args="${run_args} --zygote"
246 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800247 elif [ "x$1" = "x--interpreter" ]; then
248 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700249 image_suffix="-interpreter"
250 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800251 elif [ "x$1" = "x--jit" ]; then
252 run_args="${run_args} --jit"
Mathieu Chartiere2a12c02015-02-27 13:21:15 -0800253 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800254 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700255 elif [ "x$1" = "x--optimizing" ]; then
256 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
257 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800258 shift
Nicolas Geoffrayc9338b92014-12-03 13:36:10 +0000259 elif [ "x$1" = "x--quick" ]; then
260 run_args="${run_args} -Xcompiler-option --compiler-backend=Quick"
261 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700262 elif [ "x$1" = "x--no-verify" ]; then
263 run_args="${run_args} --no-verify"
264 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700265 elif [ "x$1" = "x--verify-soft-fail" ]; then
266 run_args="${run_args} --verify-soft-fail"
267 image_suffix="-interpreter-access-checks"
268 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700269 elif [ "x$1" = "x--no-optimize" ]; then
270 run_args="${run_args} --no-optimize"
271 shift
272 elif [ "x$1" = "x--no-precise" ]; then
273 run_args="${run_args} --no-precise"
274 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700275 elif [ "x$1" = "x--invoke-with" ]; then
276 shift
277 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700278 if [ "x$what" = "x" ]; then
279 echo "$0 missing argument to --invoke-with" 1>&2
280 usage="yes"
281 break
282 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700283 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700284 shift
285 elif [ "x$1" = "x--dev" ]; then
286 run_args="${run_args} --dev"
287 dev_mode="yes"
288 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700289 elif [ "x$1" = "x--build-only" ]; then
290 build_only="yes"
291 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100292 elif [ "x$1" = "x--build-with-javac-dx" ]; then
293 USE_JACK="false"
294 shift
295 elif [ "x$1" = "x--build-with-jack" ]; then
296 USE_JACK="true"
297 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700298 elif [ "x$1" = "x--output-path" ]; then
299 shift
300 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700301 if [ "x$tmp_dir" = "x" ]; then
302 echo "$0 missing argument to --output-path" 1>&2
303 usage="yes"
304 break
305 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700306 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000307 elif [ "x$1" = "x--android-root" ]; then
308 shift
309 if [ "x$1" = "x" ]; then
310 echo "$0 missing argument to --android-root" 1>&2
311 usage="yes"
312 break
313 fi
314 android_root="$1"
315 run_args="${run_args} --android-root $1"
316 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700317 elif [ "x$1" = "x--update" ]; then
318 update_mode="yes"
319 shift
320 elif [ "x$1" = "x--help" ]; then
321 usage="yes"
322 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700323 elif [ "x$1" = "x--64" ]; then
324 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700325 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700326 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200327 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700328 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200329 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700330 elif [ "x$1" = "x--stream" ]; then
331 trace_stream="true"
332 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700333 elif [ "x$1" = "x--always-clean" ]; then
334 always_clean="yes"
335 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700336 elif [ "x$1" = "x--never-clean" ]; then
337 never_clean="yes"
338 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800339 elif [ "x$1" = "x--dex2oat-swap" ]; then
340 run_args="${run_args} --dex2oat-swap"
341 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700342 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700343 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700344 usage="yes"
345 break
346 else
347 break
348 fi
349done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700350
351# tmp_dir may be relative, resolve.
352#
353# Cannot use realpath, as it does not exist on Mac.
354# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700355# Cannot use readlink -m, as it does not exist on Mac.
356# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700357noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700358tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700359mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700360
Alex Lighte7873ec2014-08-12 09:53:50 -0700361if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800362 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
363 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700364fi
365if [ "$gc_verify" = "true" ]; then
366 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
367fi
368if [ "$gc_stress" = "true" ]; then
Mathieu Chartiereb193622015-06-27 15:42:27 -0700369 run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700370fi
Jeff Hao85139a32014-07-23 11:52:52 -0700371if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700372 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
373 if [ "$trace_stream" = "true" ]; then
374 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
375 # the ability to analyze the file and just write to /dev/null.
376 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
377 # Enable streaming mode.
378 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
379 else
380 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
381 fi
382elif [ "$trace_stream" = "true" ]; then
383 echo "Cannot use --stream without --trace."
384 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700385fi
386
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700387# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100388# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700389function guess_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100390 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800391 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700392 if [ "x${suffix64}" = "x64" ]; then
393 target_arch_name=${grep64bit}
394 else
395 target_arch_name=${grep32bit}
396 fi
397}
398
Alex Lighta59dd802014-07-02 16:28:08 -0700399if [ "$target_mode" = "no" ]; then
400 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700401 if [ "$prebuild_mode" = "yes" ]; then
402 echo "--prebuild with --jvm is unsupported";
403 exit 1;
404 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700405 fi
406fi
407
Alex Light03a112d2014-08-25 13:25:56 -0700408if [ "$have_patchoat" = "no" ]; then
409 run_args="${run_args} --no-patchoat"
410fi
411
412if [ "$have_dex2oat" = "no" ]; then
413 run_args="${run_args} --no-dex2oat"
414fi
415
Jeff Hao201803f2013-11-20 18:11:39 -0800416if [ ! "$runtime" = "jvm" ]; then
417 run_args="${run_args} --lib $lib"
418fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700419
Jeff Hao201803f2013-11-20 18:11:39 -0800420if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700421 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100422 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700423 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
424 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
425 else
426 true # defaults to using target BOOTCLASSPATH
427 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800428elif [ "$runtime" = "art" ]; then
429 if [ "$target_mode" = "no" ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100430 # ANDROID_HOST_OUT is not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800431 if [ -z "$ANDROID_HOST_OUT" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100432 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800433 fi
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000434 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700435 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800436 else
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700437 guess_arch_name
438 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000439 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800440 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700441 if [ "$relocate" = "yes" ]; then
442 run_args="${run_args} --relocate"
443 else
444 run_args="${run_args} --no-relocate"
445 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700446elif [ "$runtime" = "jvm" ]; then
447 # TODO: Detect whether the host is 32-bit or 64-bit.
448 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700449fi
450
Alex Light03a112d2014-08-25 13:25:56 -0700451if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700452 if [ "$runtime" != "art" ]; then
453 echo "--no-image is only supported on the art runtime"
454 exit 1
455 fi
456 if [ "$target_mode" = "no" ]; then
457 framework="${ANDROID_HOST_OUT}/framework"
458 bpath_suffix="-hostdex"
459 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000460 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700461 bpath_suffix=""
462 fi
463 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
464 # fail since these jar files will be stripped.
465 bpath="${framework}/core-libart${bpath_suffix}.jar"
466 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
467 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
468 bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar"
469 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
470 # Pass down the bootclasspath
471 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700472 run_args="${run_args} --no-image"
473fi
474
jeffhao5d1ac922011-09-29 17:41:15 -0700475if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
476 echo "--dev and --update are mutually exclusive" 1>&2
477 usage="yes"
478fi
479
480if [ "$usage" = "no" ]; then
481 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
482 test_dir=`basename "$oldwd"`
483 else
484 test_dir="$1"
485 fi
486
487 if [ '!' -d "$test_dir" ]; then
488 td2=`echo ${test_dir}-*`
489 if [ '!' -d "$td2" ]; then
490 echo "${test_dir}: no such test directory" 1>&2
491 usage="yes"
492 fi
493 test_dir="$td2"
494 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700495 # Shift to get rid of the test name argument. The rest of the arguments
496 # will get passed to the test run.
497 shift
498fi
499
500if [ "$usage" = "yes" ]; then
501 prog=`basename $prog`
502 (
503 echo "usage:"
504 echo " $prog --help Print this message."
505 echo " $prog [options] [test-name] Run test normally."
506 echo " $prog --dev [options] [test-name] Development mode" \
507 "(dumps to stdout)."
508 echo " $prog --update [options] [test-name] Update mode" \
509 "(replaces expected.txt)."
510 echo ' Omitting the test name or specifying "-" will use the' \
511 "current directory."
512 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000513 echo " -O Run non-debug rather than debug build (off by default)."
514 echo " -Xcompiler-option Pass an option to the compiler."
515 echo " --runtime-option Pass an option to the runtime."
516 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000517 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000518 echo " --gdb Run under gdb; incompatible with some tests."
519 echo " --build-only Build test files only (off by default)."
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100520 echo " --build-with-javac-dx Build test files with javac and dx (on by default)."
521 echo " --build-with-jack Build test files with jack and jill (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000522 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800523 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000524 echo " --optimizing Enable optimizing compiler (default)."
525 echo " --quick Use Quick compiler (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000526 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700527 echo " --verify-soft-fail Force soft fail verification (off by default)."
528 echo " Verification is enabled if neither --no-verify"
529 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000530 echo " --no-optimize Turn off optimization (on by default)."
531 echo " --no-precise Turn off precise GC (on by default)."
532 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700533 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000534 echo " other runtime options are ignored."
535 echo " --no-dex2oat Run as though dex2oat was failing."
536 echo " --no-patchoat Run as though patchoat was failing."
537 echo " --prebuild Run dex2oat on the files before starting test. (default)"
538 echo " --no-prebuild Do not run dex2oat on the files before starting"
539 echo " the test."
540 echo " --relocate Force the use of relocating in the test, making"
541 echo " the image and oat files be relocated to a random"
542 echo " address before running. (default)"
543 echo " --no-relocate Force the use of no relocating in the test"
544 echo " --host Use the host-mode virtual machine."
545 echo " --invoke-with Pass --invoke-with option to runtime."
546 echo " --dalvik Use Dalvik (off by default)."
547 echo " --jvm Use a host-local RI virtual machine."
548 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700549 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000550 echo " --64 Run the test in 64-bit mode"
551 echo " --trace Run with method tracing"
Andreas Gampe7526d782015-06-22 22:53:45 -0700552 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000553 echo " --gcstress Run with gc stress testing"
554 echo " --gcverify Run with gc verification"
555 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700556 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000557 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000558 echo " --dex2oat-swap Use a dex2oat swap file."
jeffhao5d1ac922011-09-29 17:41:15 -0700559 ) 1>&2
560 exit 1
561fi
562
563cd "$test_dir"
564test_dir=`pwd`
565
566td_info="${test_dir}/${info}"
567td_expected="${test_dir}/${expected}"
568
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700569if [ ! -r $td_info ]; then
570 echo "${test_dir}: missing file $td_info" 1>&2
571 exit 1
572fi
573
574if [ ! -r $td_expected ]; then
575 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700576 exit 1
577fi
578
579# copy the test to a temp dir and run it
580
Elliott Hughes510c8782011-10-06 10:57:34 -0700581echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700582
583rm -rf "$tmp_dir"
584cp -Rp "$test_dir" "$tmp_dir"
585cd "$tmp_dir"
586
587if [ '!' -r "$build" ]; then
588 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800589else
590 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700591fi
592
593if [ '!' -r "$run" ]; then
594 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800595else
596 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700597fi
598
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700599if [ '!' -r "$check_cmd" ]; then
600 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800601else
602 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700603fi
604
jeffhao5d1ac922011-09-29 17:41:15 -0700605chmod 755 "$build"
606chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700607chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700608
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700609export TEST_NAME=`basename ${test_dir}`
610
David Brazdil4846d132015-01-15 19:07:08 +0000611# Tests named '<number>-checker-*' will also have their CFGs verified with
612# Checker when compiled with Optimizing on host.
613if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
614 # Build Checker DEX files without dx's optimizations so the input to dex2oat
615 # better resembles the Java source. We always build the DEX the same way, even
616 # if Checker is not invoked and the test only runs the program.
617 build_args="${build_args} --dx-option --no-optimize"
618
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100619 # Jack does not necessarily generate the same DEX output than dx. Because these tests depend
620 # on a particular DEX output, keep building them with dx for now (b/19467889).
621 USE_JACK="false"
622
Nicolas Geoffraye7307292015-03-17 18:12:06 +0000623 if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$target_mode" = "no" -a "$debuggable" = "no" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000624 run_checker="yes"
625 run_args="${run_args} -Xcompiler-option --dump-cfg=$tmp_dir/$cfg_output \
626 -Xcompiler-option -j1"
627 fi
628fi
629
Ian Rogers997f0f92014-06-21 22:58:05 -0700630# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100631build_file_size_limit=2048
632run_file_size_limit=2048
Ian Rogers997f0f92014-06-21 22:58:05 -0700633if echo "$test_dir" | grep 089; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100634 build_file_size_limit=5120
635 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700636elif echo "$test_dir" | grep 083; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100637 build_file_size_limit=5120
638 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700639fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100640if [ ${USE_JACK} = "false" ]; then
641 # Set ulimit if we build with dx only, Jack can generate big temp files.
642 if ! ulimit -S "$build_file_size_limit"; then
643 echo "ulimit file size setting failed"
644 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700645fi
646
jeffhao5d1ac922011-09-29 17:41:15 -0700647good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000648good_build="yes"
649good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700650if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000651 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700652 build_exit="$?"
653 echo "build exit status: $build_exit" 1>&2
654 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100655 if ! ulimit -S "$run_file_size_limit"; then
656 echo "ulimit file size setting failed"
657 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800658 echo "${test_dir}: running..." 1>&2
659 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700660 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000661
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800662 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000663 if [ "$run_checker" = "yes" ]; then
664 "$checker" "$cfg_output" "$tmp_dir" 2>&1
665 checker_exit="$?"
666 if [ "$checker_exit" = "0" ]; then
667 good="yes"
668 fi
669 echo "checker exit status: $checker_exit" 1>&2
670 else
671 good="yes"
672 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800673 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000674 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700675 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700676elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000677 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700678 build_exit="$?"
679 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100680 if ! ulimit -S "$run_file_size_limit"; then
681 echo "ulimit file size setting failed"
682 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800683 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700684 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000685 if [ "$run_checker" = "yes" ]; then
686 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
687 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700688 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
689 good="yes"
690 else
691 cat "$build_output" 1>&2
692 echo "build exit status: $build_exit" 1>&2
693 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700694elif [ "$build_only" = "yes" ]; then
695 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000696 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700697 build_exit="$?"
698 if [ "$build_exit" '!=' '0' ]; then
699 cp "$build_output" "$output"
700 echo "build exit status: $build_exit" >>"$output"
701 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
702 if [ "$?" '!=' "0" ]; then
703 good="no"
704 echo "BUILD FAILED For ${TEST_NAME}"
705 fi
706 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700707 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700708 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700709 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700710else
David Brazdil4846d132015-01-15 19:07:08 +0000711 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700712 build_exit="$?"
713 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100714 if ! ulimit -S "$run_file_size_limit"; then
715 echo "ulimit file size setting failed"
716 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800717 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700718 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000719 run_exit="$?"
720 if [ "$run_exit" != "0" ]; then
721 echo "run exit status: $run_exit" 1>&2
722 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000723 elif [ "$run_checker" = "yes" ]; then
724 "$checker" -q "$cfg_output" "$tmp_dir" >> "$output" 2>&1
725 checker_exit="$?"
726 if [ "$checker_exit" != "0" ]; then
727 echo "checker exit status: $checker_exit" 1>&2
728 good_run="no"
729 else
730 good_run="yes"
731 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000732 else
733 good_run="yes"
734 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700735 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000736 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700737 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700738 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
739 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700740 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700741 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700742 max_name_length=$(getconf NAME_MAX ${tmp_dir})
743 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
744 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700745 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700746 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700747 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700748 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000749 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
750 # output == expected
751 good="yes"
752 echo "${test_dir}: succeeded!" 1>&2
753 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700754 fi
755fi
756
jeffhao5d1ac922011-09-29 17:41:15 -0700757(
Alex Lightbfac14a2014-07-30 09:41:21 -0700758 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700759 echo "${test_dir}: FAILED!"
760 echo ' '
761 echo '#################### info'
762 cat "${td_info}" | sed 's/^/# /g'
763 echo '#################### diffs'
Ian Rogers75deec02014-11-23 20:07:39 -0800764 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000
jeffhao5d1ac922011-09-29 17:41:15 -0700765 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700766 if [ "$strace" = "yes" ]; then
767 echo '#################### strace output'
768 tail -n 2000 "$tmp_dir/$strace_output"
769 echo '####################'
770 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700771 echo ' '
772 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700773
774) 1>&2
775
776# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700777if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700778 cd "$oldwd"
779 rm -rf "$tmp_dir"
780 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
781 adb shell rm -rf $DEX_LOCATION
782 fi
783 if [ "$good" = "yes" ]; then
784 exit 0
785 fi
786fi
787
788
789(
790 if [ "$always_clean" = "yes" ]; then
791 echo "${TEST_NAME} files deleted from host "
792 if [ "$target_mode" == "yes" ]; then
793 echo "and from target"
794 fi
795 else
796 echo "${TEST_NAME} files left in ${tmp_dir} on host"
797 if [ "$target_mode" == "yes" ]; then
798 echo "and in ${DEX_LOCATION} on target"
799 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700800 fi
801
jeffhao5d1ac922011-09-29 17:41:15 -0700802) 1>&2
803
804exit 1